<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: empirical_kernel_map.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_5e84fc1d53d6c0d63218f3bf54f21eee.html">svm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">empirical_kernel_map.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2009  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_EMPIRICAL_KERNEl_MAP_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_EMPIRICAL_KERNEl_MAP_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;empirical_kernel_map_abstract.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;linearly_independent_subset_finder.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;kernel_matrix.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;function.h&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;{</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> kernel_type, <span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="keyword">const</span> decision_function&lt;kernel_type&gt; convert_to_decision_function (</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <span class="keyword">const</span> projection_function&lt;kernel_type&gt;&amp; project_funct,</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; vect</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    ) </div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    {</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        DLIB_ASSERT(project_funct.out_vector_size() &gt; 0 &amp;&amp; is_vector(vect) &amp;&amp; </div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;                    project_funct.out_vector_size() == vect.size() &amp;&amp; project_funct.weights.nc() == project_funct.basis_vectors.size(),</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;            <span class="stringliteral">&quot;\t const decision_function convert_to_decision_function()&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t Invalid inputs to this function.&quot;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t project_funct.out_vector_size():    &quot;</span> &lt;&lt; project_funct.out_vector_size() </div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t project_funct.weights.nc():         &quot;</span> &lt;&lt; project_funct.weights.nc() </div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t project_funct.basis_vectors.size(): &quot;</span> &lt;&lt; project_funct.basis_vectors.size() </div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t is_vector(vect):                    &quot;</span> &lt;&lt; is_vector(vect) </div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t vect.size():                        &quot;</span> &lt;&lt; vect.size() </div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;            );</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordflow">return</span> decision_function&lt;kernel_type&gt;(trans(project_funct.weights)*vect, </div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;                                              0, </div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;                                              project_funct.kernel_function,</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;                                              project_funct.basis_vectors);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    }</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> kern_type&gt;</div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classdlib_1_1empirical__kernel__map.html">   46</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1empirical__kernel__map.html">empirical_kernel_map</a></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    {</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="structdlib_1_1empirical__kernel__map_1_1empirical__kernel__map__error.html">   50</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="structdlib_1_1empirical__kernel__map_1_1empirical__kernel__map__error.html">empirical_kernel_map_error</a> : <span class="keyword">public</span> <a class="code" href="classdlib_1_1error.html">error</a></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        {</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            <a class="code" href="structdlib_1_1empirical__kernel__map_1_1empirical__kernel__map__error.html">empirical_kernel_map_error</a>(<span class="keyword">const</span> std::string&amp; message): <a class="code" href="classdlib_1_1error.html#a7aa811457dae46c97d8b9ecc696b0559">error</a>(message) {}</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        };</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keyword">typedef</span> kern_type kernel_type;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::sample_type sample_type;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::scalar_type scalar_type;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keywordtype">void</span> clear (</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        )</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        {</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            <a class="code" href="classdlib_1_1empirical__kernel__map.html">empirical_kernel_map</a>().swap(*<span class="keyword">this</span>);</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        }</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordtype">void</span> load(</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;            <span class="keyword">const</span> kernel_type&amp; kernel_,</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            <span class="keyword">const</span> T&amp; basis_samples</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        )</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        {</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            load_impl(kernel_, mat(basis_samples));</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        }</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keywordtype">void</span> load(</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            <span class="keyword">const</span> linearly_independent_subset_finder&lt;kernel_type&gt;&amp; lisf</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        )</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        {</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            <span class="keywordflow">if</span> (lisf.size() == 0)</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            {</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;                std::ostringstream sout;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;                sout &lt;&lt; <span class="stringliteral">&quot;An empty linearly_independent_subset_finder was supplied to the\n&quot;</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;                     &lt;&lt; <span class="stringliteral">&quot;empirical_kernel_map::load() function.  One reason this might occur\n&quot;</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;                     &lt;&lt; <span class="stringliteral">&quot;is if your dataset contains only zero vectors (or vectors \n&quot;</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                     &lt;&lt; <span class="stringliteral">&quot;approximately zero).\n&quot;</span>;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;                clear();</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;                <span class="keywordflow">throw</span> empirical_kernel_map_error(sout.str());</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            }</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            kernel = lisf.get_kernel();</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            weights = trans(chol(lisf.get_inv_kernel_marix()));</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            basis.resize(lisf.size());</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; basis.size(); ++i)</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;                basis[i] = lisf[i];</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        }</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160; </div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keyword">const</span> kernel_type get_kernel (</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            DLIB_ASSERT(out_vector_size() &gt; 0,</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;                <span class="stringliteral">&quot;\tconst kernel_type empirical_kernel_map::get_kernel()&quot;</span></div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t You have to load this object with a kernel before you can call this function&quot;</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t this: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;                );</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;            <span class="keywordflow">return</span> kernel;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        }</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keywordtype">long</span> out_vector_size (</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            <span class="keywordflow">return</span> weights.nr();</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        }</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160; </div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> basis_size (</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            <span class="keywordflow">return</span> basis.size();</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        }</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keyword">const</span> sample_type&amp; operator[] (</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> idx</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            DLIB_ASSERT( idx &lt; basis_size(),</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;                <span class="stringliteral">&quot;\t const sample_type&amp; empirical_kernel_map::operator[](idx)&quot;</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t Invalid inputs to this function.&quot;</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t basis_size(): &quot;</span> &lt;&lt; basis_size() </div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t this:         &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;                );</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;            <span class="keywordflow">return</span> basis[idx];</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        }</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160; </div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="keyword">const</span> decision_function&lt;kernel_type&gt; convert_to_decision_function (</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; vect</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;            DLIB_ASSERT(out_vector_size() != 0 &amp;&amp; is_vector(vect) &amp;&amp; out_vector_size() == vect.size(),</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;                <span class="stringliteral">&quot;\t const decision_function empirical_kernel_map::convert_to_decision_function()&quot;</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t Invalid inputs to this function.&quot;</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t out_vector_size(): &quot;</span> &lt;&lt; out_vector_size() </div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t is_vector(vect):   &quot;</span> &lt;&lt; is_vector(vect) </div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t vect.size():       &quot;</span> &lt;&lt; vect.size() </div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t this: &quot;</span> &lt;&lt; this</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;                );</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160; </div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;            <span class="keywordflow">return</span> decision_function&lt;kernel_type&gt;(trans(weights)*vect, 0, kernel, mat(basis));</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        }</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160; </div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        <span class="keyword">const</span> distance_function&lt;kernel_type&gt; convert_to_distance_function (</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; vect</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            DLIB_ASSERT(out_vector_size() != 0 &amp;&amp; is_vector(vect) &amp;&amp; out_vector_size() == vect.size(),</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;                <span class="stringliteral">&quot;\t const distance_function empirical_kernel_map::convert_to_distance_function()&quot;</span></div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t Invalid inputs to this function.&quot;</span></div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t out_vector_size(): &quot;</span> &lt;&lt; out_vector_size() </div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t is_vector(vect):   &quot;</span> &lt;&lt; is_vector(vect) </div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t vect.size():       &quot;</span> &lt;&lt; vect.size() </div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t this: &quot;</span> &lt;&lt; this</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                );</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160; </div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            <span class="keywordflow">return</span> distance_function&lt;kernel_type&gt;(trans(weights)*vect, dot(vect,vect), kernel, mat(basis));</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        }</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160; </div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="keyword">const</span> projection_function&lt;kernel_type&gt; get_projection_function (</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;            DLIB_ASSERT(out_vector_size() != 0,</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                <span class="stringliteral">&quot;\tconst projection_function empirical_kernel_map::get_projection_function()&quot;</span></div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t You have to load this object with data before you can call this function&quot;</span></div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t this: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;                );</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160; </div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;            <span class="keywordflow">return</span> projection_function&lt;kernel_type&gt;(weights, kernel, mat(basis));</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        }</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160; </div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        <span class="keyword">const</span> matrix&lt;scalar_type,0,0,mem_manager_type&gt; get_transformation_to (</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;            <span class="keyword">const</span> empirical_kernel_map&amp; target</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            DLIB_ASSERT(out_vector_size() != 0 &amp;&amp; </div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;                        target.out_vector_size() != 0 &amp;&amp;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;                        get_kernel() == target.get_kernel(),</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;                <span class="stringliteral">&quot;\t const matrix empirical_kernel_map::get_transformation_to(target)&quot;</span></div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t Invalid inputs were given to this function&quot;</span></div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t out_vector_size():                 &quot;</span> &lt;&lt; out_vector_size() </div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t target.out_vector_size():          &quot;</span> &lt;&lt; target.out_vector_size() </div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t get_kernel()==target.get_kernel(): &quot;</span> &lt;&lt; (get_kernel()==target.get_kernel())</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t this: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;                );</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160; </div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;            <span class="keywordflow">return</span> target.weights * kernel_matrix(target.get_kernel(),target.basis, basis)*trans(weights);</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        }</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160; </div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        <span class="keywordtype">void</span> get_transformation_to (</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;            <span class="keyword">const</span> empirical_kernel_map&amp; target,</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            matrix&lt;scalar_type, 0, 0, mem_manager_type&gt;&amp; tmat,</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;            projection_function&lt;kernel_type&gt;&amp; partial_projection</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            DLIB_ASSERT(out_vector_size() != 0 &amp;&amp; </div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;                        target.out_vector_size() != 0 &amp;&amp;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;                        get_kernel() == target.get_kernel() &amp;&amp;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;                        basis_size() &lt; target.basis_size(),</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;                <span class="stringliteral">&quot;\t void empirical_kernel_map::get_transformation_to(target, tmat, partial_projection)&quot;</span></div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t Invalid inputs were given to this function&quot;</span></div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t out_vector_size():                 &quot;</span> &lt;&lt; out_vector_size() </div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t target.out_vector_size():          &quot;</span> &lt;&lt; target.out_vector_size() </div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t basis_size():                      &quot;</span> &lt;&lt; basis_size() </div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t target.basis_size():               &quot;</span> &lt;&lt; target.basis_size() </div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t get_kernel()==target.get_kernel(): &quot;</span> &lt;&lt; (get_kernel()==target.get_kernel())</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t this: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;                );</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160; </div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="preprocessor">#ifdef ENABLE_ASSERTS</span></div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; basis_size(); ++i)</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            {</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;                DLIB_ASSERT(dlib::equal((*<span class="keyword">this</span>)[i], target[i]), </div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;                    <span class="stringliteral">&quot;\t const matrix empirical_kernel_map::get_transformation_to(target, tmat, partial_projection)&quot;</span></div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t target must contain a superset of the basis vectors in *this&quot;</span></div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t i: &quot;</span> &lt;&lt; i</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t this: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;                    );</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;            }</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160; </div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num1 = basis.size();</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num2 = target.basis.size();</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160; </div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;            tmat = colm(target.weights, range(0,num1-1))*kernel_matrix(kernel, basis)*trans(weights);</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160; </div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;            empirical_kernel_map temp_ekm;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;            temp_ekm.load(kernel, rowm(mat(target.basis), range(num1,num2-1)));</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160; </div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;            partial_projection = temp_ekm.get_projection_function();</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160; </div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;            partial_projection.weights = colm(target.weights,range(num1,num2-1))*</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;                                   kernel_matrix(kernel, temp_ekm.basis)*</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;                                   trans(temp_ekm.weights)*</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;                                   partial_projection.weights;</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        }</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160; </div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        <span class="keyword">const</span> matrix&lt;scalar_type,0,1,mem_manager_type&gt;&amp; project (</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            <span class="keyword">const</span> sample_type&amp; samp</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;            DLIB_ASSERT(out_vector_size() != 0,</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;                <span class="stringliteral">&quot;\tconst matrix empirical_kernel_map::project()&quot;</span></div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t You have to load this object with data before you can call this function&quot;</span></div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t this: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;                );</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160; </div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;            temp1 = kernel_matrix(kernel, basis, samp);</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;            temp2 = weights*temp1;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;            <span class="keywordflow">return</span> temp2;</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        }</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160; </div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        <span class="keyword">const</span> matrix&lt;scalar_type,0,1,mem_manager_type&gt;&amp; project (</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;            <span class="keyword">const</span> sample_type&amp; samp,</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;            scalar_type&amp; projection_error </div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            DLIB_ASSERT(out_vector_size() != 0,</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;                <span class="stringliteral">&quot;\tconst matrix empirical_kernel_map::project()&quot;</span></div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t You have to load this object with data before you can call this function&quot;</span></div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t this: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;                );</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160; </div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            temp1 = kernel_matrix(kernel, basis, samp);</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            temp2 = weights*temp1;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;            <span class="comment">// This value should never be negative (it measures squared distance) but I&#39;m putting the abs() </span></div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            <span class="comment">// here just for good measure since rounding error might push it slightly negative.</span></div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            projection_error = std::abs( kernel(samp,samp) - dot(temp2,temp2));</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160; </div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;            <span class="keywordflow">return</span> temp2;</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        }</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160; </div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            empirical_kernel_map&amp; item</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        )</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        {</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;            basis.swap(item.basis);</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;            weights.swap(item.weights);</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;            std::swap(kernel, item.kernel);</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160; </div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;            temp1.swap(item.temp1);</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;            temp2.swap(item.temp2);</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        }</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160; </div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">void</span> serialize (</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;            <span class="keyword">const</span> empirical_kernel_map&amp; item,</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;            std::ostream&amp; out</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        )</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        {</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;            serialize(item.basis, out);</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;            serialize(item.weights, out);</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;            serialize(item.kernel, out);</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        }</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160; </div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">void</span> deserialize (</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;            empirical_kernel_map&amp; item,</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;            std::istream&amp; in </div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        )</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        {</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;            deserialize(item.basis, in);</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;            deserialize(item.weights, in);</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;            deserialize(item.kernel, in);</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;        }</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160; </div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160; </div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        <span class="keywordtype">void</span> load_impl(</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;            <span class="keyword">const</span> kernel_type&amp; kernel_,</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;            <span class="keyword">const</span> T&amp; basis_samples</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;        )</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;        {</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;            DLIB_ASSERT(basis_samples.size() &gt; 0 &amp;&amp; is_vector(basis_samples),</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;                <span class="stringliteral">&quot;\tvoid empirical_kernel_map::load(kernel,basis_samples)&quot;</span></div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t You have to give a non-empty set of basis_samples and it must be a vector&quot;</span></div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t basis_samples.size():     &quot;</span> &lt;&lt; basis_samples.size() </div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t is_vector(basis_samples): &quot;</span> &lt;&lt; is_vector(basis_samples) </div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t this: &quot;</span> &lt;&lt; this</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;                );</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160; </div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;            <span class="comment">// clear out the weights before we begin.  This way if an exception throws</span></div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;            <span class="comment">// this object will already be in the right state.</span></div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;            weights.set_size(0,0);</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;            kernel = kernel_;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;            basis.clear();</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;            basis.reserve(basis_samples.size());</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160; </div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;            <span class="comment">// find out the value of the largest norm of the elements in basis_samples.</span></div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;            <span class="keyword">const</span> scalar_type max_norm = max(diag(kernel_matrix(kernel, basis_samples)));</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;            <span class="comment">// we will consider anything less than or equal to this number to be 0</span></div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;            <span class="keyword">const</span> scalar_type eps = max_norm*100*std::numeric_limits&lt;scalar_type&gt;::epsilon();</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160; </div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;            <span class="comment">// Copy all the basis_samples into basis but make sure we don&#39;t copy any samples</span></div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;            <span class="comment">// that have length 0</span></div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; basis_samples.size(); ++i)</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;            {</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;                <span class="keyword">const</span> scalar_type norm = kernel(basis_samples(i), basis_samples(i));</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;                <span class="keywordflow">if</span> (norm &gt; eps)</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;                {</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;                    basis.push_back(basis_samples(i));</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;                }</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;            }</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160; </div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;            <span class="keywordflow">if</span> (basis.size() == 0)</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;            {</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;                clear();</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;                <span class="keywordflow">throw</span> empirical_kernel_map_error(<span class="stringliteral">&quot;All basis_samples given to empirical_kernel_map::load() were zero vectors&quot;</span>);</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;            }</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160; </div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;            matrix&lt;scalar_type,0,0,mem_manager_type&gt; K(kernel_matrix(kernel, basis)), U,W,V;</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160; </div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;            <span class="keywordflow">if</span> (svd2(<span class="keyword">false</span>,<span class="keyword">true</span>,K,U,W,V))</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;            {</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;                clear();</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;                <span class="keywordflow">throw</span> empirical_kernel_map_error(<span class="stringliteral">&quot;While loading empirical_kernel_map with data, SVD failed to converge.&quot;</span>);</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;            }</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160; </div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160; </div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;            <span class="comment">// now count how many elements of W are non-zero</span></div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">long</span> num_not_zero = static_cast&lt;long&gt;(sum(W&gt;eps));</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160; </div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;            <span class="comment">// Really, this should never happen.  But I&#39;m checking for good measure.</span></div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;            <span class="keywordflow">if</span> (num_not_zero == 0)</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;            {</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;                clear();</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;                <span class="keywordflow">throw</span> empirical_kernel_map_error(<span class="stringliteral">&quot;While loading empirical_kernel_map with data, SVD failed&quot;</span>);</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;            }</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160; </div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;            weights.set_size(num_not_zero, basis.size());</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160; </div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;            <span class="comment">// now fill the weights matrix with the output of the SVD</span></div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;            <span class="keywordtype">long</span> counter = 0;</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i =0; i &lt; W.size(); ++i)</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;            {</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;                <span class="keywordtype">double</span> val = W(i);</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;                <span class="keywordflow">if</span> (val &gt; eps)</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;                {</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;                    val = std::sqrt(val);</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;                    set_rowm(weights,counter) = rowm(trans(V),i)/val;</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;                    ++counter;</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;                }</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;            }</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160; </div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;        }</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160; </div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160; </div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;        std::vector&lt;sample_type&gt; basis;</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;        matrix&lt;scalar_type,0,0,mem_manager_type&gt; weights;</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;        kernel_type kernel;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160; </div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;        <span class="comment">// These members don&#39;t contribute to the logical state of this object.  They are</span></div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        <span class="comment">// just here so that they don&#39;t have to be reallocated every time the project() function</span></div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;        <span class="comment">// is called.</span></div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;        <span class="keyword">mutable</span> matrix&lt;scalar_type,0,1,mem_manager_type&gt; temp1, temp2;</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160; </div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;    };</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160; </div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> kernel_type&gt;</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;    <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;        empirical_kernel_map&lt;kernel_type&gt;&amp; a,</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;        empirical_kernel_map&lt;kernel_type&gt;&amp; b</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;    ) { a.swap(b); }</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;    </div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160; </div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;}</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160; </div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;<span class="preprocessor">#endif // DLIB_EMPIRICAL_KERNEl_MAP_H_</span></div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1empirical__kernel__map_html"><div class="ttname"><a href="classdlib_1_1empirical__kernel__map.html">dlib::empirical_kernel_map</a></div><div class="ttdef"><b>Definition:</b> empirical_kernel_map.h:46</div></div>
<div class="ttc" id="aclassdlib_1_1error_html_a7aa811457dae46c97d8b9ecc696b0559"><div class="ttname"><a href="classdlib_1_1error.html#a7aa811457dae46c97d8b9ecc696b0559">dlib::error::error</a></div><div class="ttdeci">error()</div><div class="ttdef"><b>Definition:</b> error.h:99</div></div>
<div class="ttc" id="astructdlib_1_1empirical__kernel__map_1_1empirical__kernel__map__error_html"><div class="ttname"><a href="structdlib_1_1empirical__kernel__map_1_1empirical__kernel__map__error.html">dlib::empirical_kernel_map::empirical_kernel_map_error</a></div><div class="ttdef"><b>Definition:</b> empirical_kernel_map.h:50</div></div>
<div class="ttc" id="aclassdlib_1_1error_html"><div class="ttname"><a href="classdlib_1_1error.html">dlib::error</a></div><div class="ttdef"><b>Definition:</b> error.h:62</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
